Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
Botan::Entropy_Source Class Referenceabstract

`#include <entropy_src.h>`

Inheritance diagram for Botan::Entropy_Source:

## Public Member Functions
virtual std::string | name () const =0
virtual size_t | poll (RandomNumberGenerator &rng)=0
virtual | ~Entropy_Source ()

## Static Public Member Functions
static std::unique_ptr< Entropy_Source > | create (const std::string &type)

## Detailed Description

Abstract interface to a source of entropy

Definition at line 25 of file entropy_src.h.

## Constructor & Destructor Documentation

virtual Botan::Entropy_Source::~Entropy_Source | ( |  | ) |
| inline virtual

Definition at line 48 of file entropy_src.h.

48 {}

## Member Function Documentation

std::unique_ptr< Entropy_Source > Botan::Entropy_Source::create | ( | const std::string & | type | ) |
| static

Return a new entropy source of a particular type, or null Each entropy source may require substantial resources (eg, a file handle or socket instance), so try to share them among multiple RNGs, or just use the preconfigured global list accessed by Entropy_Sources::global_sources()

Definition at line 45 of file entropy_srcs.cpp.

Referenced by Botan::Entropy_Sources::Entropy_Sources().

46 {
47 if(name == "rdrand")
48 {
49 #if defined(BOTAN_HAS_ENTROPY_SRC_RDRAND)
50 return std::unique_ptr<Entropy_Source>(new Intel_Rdrand);
51 #endif
52 }
53
54 if(name == "rdseed")
55 {
56 #if defined(BOTAN_HAS_ENTROPY_SRC_RDSEED)
57 return std::unique_ptr<Entropy_Source>(new Intel_Rdseed);
58 #endif
59 }
60
61 if(name == "darwin_secrandom")
62 {
63 #if defined(BOTAN_HAS_ENTROPY_SRC_DARWIN_SECRANDOM)
64 return std::unique_ptr<Entropy_Source>(new Darwin_SecRandom);
65 #endif
66 }
67
68 if(name == "getentropy")
69 {
70 #if defined(BOTAN_HAS_ENTROPY_SRC_GETENTROPY)
71 return std::unique_ptr<Entropy_Source>(new Getentropy);
72 #endif
73 }
74
75 if(name == "dev_random")
76 {
77 #if defined(BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM)
78 return std::unique_ptr<Entropy_Source>(new Device_EntropySource(BOTAN_SYSTEM_RNG_POLL_DEVICES));
79 #endif
80 }
81
82 if(name == "win32_cryptoapi")
83 {
84 #if defined(BOTAN_HAS_ENTROPY_SRC_CAPI)
85 return std::unique_ptr<Entropy_Source>(new Win32_CAPI_EntropySource("RSA_FULL"));
86 #endif
87 }
88
89 if(name == "proc_walk")
90 {
91 #if defined(BOTAN_HAS_ENTROPY_SRC_PROC_WALKER)
92 const std::string root_dir = BOTAN_ENTROPY_PROC_FS_PATH;
93 if(!root_dir.empty())
94 return std::unique_ptr<Entropy_Source>(new ProcWalking_EntropySource(root_dir));
95 #endif
96 }
97
98 if(name == "system_stats")
99 {
100 #if defined(BOTAN_HAS_ENTROPY_SRC_WIN32)
101 return std::unique_ptr<Entropy_Source>(new Win32_EntropySource);
102 #endif
103 }
104
105 return std::unique_ptr<Entropy_Source>();
106 }
Botan::Entropy_Source::name
virtual std::string name() const =0

virtual std::string Botan::Entropy_Source::name | ( |  | ) | const
| pure virtual

Returns
  name identifying this entropy source

Implemented in Botan::ProcWalking_EntropySource, Botan::Device_EntropySource, Botan::Win32_CAPI_EntropySource, Botan::Getentropy, Botan::Intel_Rdrand, Botan::Intel_Rdseed, Botan::Darwin_SecRandom, and Botan::Win32_EntropySource.

virtual size_t Botan::Entropy_Source::poll | ( | RandomNumberGenerator & | rng | ) |
| pure virtual

Perform an entropy gathering poll

Parameters

  rng | will be provided with entropy via calls to add_entropy

Returns
  conservative estimate of actual entropy added to rng during poll

Implemented in Botan::ProcWalking_EntropySource, Botan::Device_EntropySource, Botan::Win32_CAPI_EntropySource, Botan::Darwin_SecRandom, Botan::Getentropy, Botan::Intel_Rdrand, Botan::Intel_Rdseed, and Botan::Win32_EntropySource.

The documentation for this class was generated from the following files:

- src/lib/entropy/entropy_src.h
- src/lib/entropy/entropy_srcs.cpp